/** @type {import('tailwindcss').Config} */
module.exports = {
  variants: {
    fill: ["hover", "focus"], // this line does the trick
  },
  extend: {
    fontFamily: {
      mono: [
        "var(--font-mono)",
        "ui-monospace",
        "SFMono-Regular",
        "Courier",
        "monospace",
      ],
      serif: ["swear-display-cilati", "Times New Roman", "serif"],
      sans: [
        "neue-haas-unica",
        "-apple-system",
        "BlinkMacSystemFont",
        "Segoe UI",
        "Roboto",
        "Oxygen",
        "Ubuntu",
        "Cantarell",
        "Fira Sans",
        "Droid Sans",
        "Helvetica Neue",
        "sans-serif",
      ],
    },
    colors: {
      white: "#e4ebfa",
      "gray-300": "#ccc",
      "gray-500": "#555",
      "gray-600": "#444",
      "gray-700": "#333",
      "gray-800": "#222",
      "slate-300": "#bdc3cf",
      "slate-400": "#a5aab4",
      "slate-500": "#7b7e85",
      "slate-900": "#1e1e1e",
      "neutral-200": "#eee",
      "neutral-500": "#777",
      "neutral-600": "#666",
      "neutral-800": "#444",
      black: "#111",
      "red-400": "#f59c9c",
      "amber-200": "#fadf98",
      "green-100": "#eeffec",
      "green-200": "#dbf7d7",
      "green-300": "#c3f2bc",
      "emerald-700": "#728a6f",
      blue: "#b8ceff",
      "blue-300": "#dce7ff",
      "blue-400": "#a1bfff",
      "blue-500": "#92b4fb",
      "blue-600": "#3a70e3",
    },
    fontSize: {
      "6xl": "64px",
    },
    maxWidth: {
      "8xl": "90rem",
    },
    animation: {
      "delayed-fade": "delay-fade 1s ease",
    },
    keyframes: {
      "delay-fade": {
        "0%, 50%": { opacity: 0 },
        "100%": { opacity: 1 },
      },
    },

    typography: (theme) => ({
      "mailing-dark": {
        css: {
          "--tw-prose-body": theme("colors.white"),
          "--tw-prose-headings": theme("colors.white"),
          "--tw-prose-lead": theme("colors.white"),
          "--tw-prose-links": theme("colors.white"),
          "--tw-prose-bold": theme("colors.white"),
          "--tw-prose-counters": theme("colors.white"),
          "--tw-prose-bullets": theme("colors.white"),
          "--tw-prose-hr": theme("colors.white"),
          "--tw-prose-quotes": theme("colors.white"),
          "--tw-prose-quote-borders": theme("colors.white"),
          "--tw-prose-captions": theme("colors.white"),
          "--tw-prose-code": theme("colors.white"),
          "--tw-prose-pre-code": theme("colors.white"),
          "--tw-prose-pre-bg": theme("colors.gray-800"),
          "--tw-prose-th-borders": theme("colors.white"),
          "--tw-prose-td-borders": theme("colors.white"),
          "--tw-prose-invert-body": theme("colors.white"),
          "--tw-prose-invert-headings": theme("colors.white"),
          "--tw-prose-invert-lead": theme("colors.white"),
          "--tw-prose-invert-links": theme("colors.white"),
          "--tw-prose-invert-bold": theme("colors.white"),
          "--tw-prose-invert-counters": theme("colors.white"),
          "--tw-prose-invert-bullets": theme("colors.white"),
          "--tw-prose-invert-hr": theme("colors.white"),
          "--tw-prose-invert-quotes": theme("colors.white"),
          "--tw-prose-invert-quote-borders": theme("colors.white"),
          "--tw-prose-invert-captions": theme("colors.white"),
          "--tw-prose-invert-code": theme("colors.white"),
          "--tw-prose-invert-pre-code": theme("colors.white"),
          "--tw-prose-invert-pre-bg": "rgb(0 0 0 / 50%)",
          "--tw-prose-invert-th-borders": theme("colors.white"),
          "--tw-prose-invert-td-borders": theme("colors.white"),
        },
      },
    }),
  },
};
